#include <stdio.h>
#include <string.h>
#include "rectangle.h"
#include "plano.h"
#include "comando.h"

int main() {
    Rectangle* retangulos[10]; // Array de ponteiros para retângulos
    int numRetangulos = 0; // Número atual de retângulos

    int opcao; // Variável para armazenar a opção do menu
    char entrada[500]; // Array para armazenar a entrada do utilizador
    char comandos[10][500]; // Array para armazenar os comandos inseridos
    int indice_comandos = 0; // Índice atual dos comandos inseridos
    char plano[ALTURA_MUNDO][LARGURA_MUNDO]; // Array bidimensional para representar o plano

    startPlano(plano); // Inicializa o plano com espaços vazios

    do {
        printf("\nMenu:\n");
        printf("1. Inserir comandos\n");
        printf("2. Ver o mundo dos retangulos\n");
        printf("3. Reset mundo dos retangulos\n");
        printf("4. Sair\n");
        printf("Escolha uma opcao: ");
        scanf("%d", &opcao); // Lê a opção do utilizador

        switch (opcao) {
            case 1: {
                while (getchar() != '\n'); // Limpa o buffer do teclado
                printf("Insira os comandos separados por ENTER (pressione ENTER em uma linha vazia para confirmar):\n");
                while (1) {
                    fgets(entrada, sizeof(entrada), stdin); // Lê uma linha de comando
                    if (entrada[0] != '\n') {
                        strcpy(comandos[indice_comandos++], entrada); // Copia o comando para o array de comandos
                    } else {
                        break; // Sai do loop quando uma linha vazia é inserida
                    }
                }

                for (int i = 0; i < indice_comandos; i++) {
                    runComando(comandos[i], retangulos, &numRetangulos); // Executa os comandos inseridos
                }

                indice_comandos = 0; // Reseta o índice dos comandos
                memset(comandos, 0, sizeof(comandos)); // Limpa o array de comandos
                break;
            }
            case 2:
                printPlano(retangulos, numRetangulos, plano); // Imprime o mundo dos retângulos
                break;
            case 3:
                for (int i = 0; i < numRetangulos; i++) {
                    freeRectangle(retangulos[i]); // Libera a memória alocada para os retângulos
                }
                numRetangulos = 0; // Reseta o número de retângulos
                startPlano(plano); // Reinicia o mundo dos retângulos
                printf("Mundo dos retângulos resetado.\n");
                break;
            case 4:
                printf("Saindo...\n");
                break;
            default:
                printf("Opcao invalida!\n");
        }
    } while (opcao != 4); // Continua o loop até que o usuário escolha sair

    for (int i = 0; i < numRetangulos; i++) {
        freeRectangle(retangulos[i]); // Libera a memória alocada para os retângulos
    }

    return 0;
}