#include <stdio.h>
#include "plano.h"

// Função para inicializar o plano com espaços vazios
void startPlano(char plano[ALTURA_MUNDO][LARGURA_MUNDO]) {
    for (int i = 0; i < ALTURA_MUNDO; i++) {
        for (int j = 0; j < LARGURA_MUNDO; j++) {
            plano[i][j] = ' ';
        }
    }
}

// Função para imprimir o plano com os retângulos representados por 'X'
void printPlano(Rectangle** retangulos, int numRetangulos, char plano[ALTURA_MUNDO][LARGURA_MUNDO]) {
    startPlano(plano); // Inicializa o plano com espaços vazios

    // Desenha os retângulos no plano
    for (int k = 0; k < numRetangulos; k++) {
        Rectangle* rect = retangulos[k];

        for (int j = rect->x; j < rect->x + rect->l; j++) {
            plano[ALTURA_MUNDO - 1 - rect->y][j] = 'X'; // Linha superior do retângulo
            plano[ALTURA_MUNDO - 1 - (rect->y + rect->h - 1)][j] = 'X'; // Linha inferior do retângulo
        }

        for (int i = rect->y + 1; i < rect->y + rect->h - 1; i++) {
            plano[ALTURA_MUNDO - 1 - i][rect->x] = 'X'; // Lado esquerdo do retângulo
            plano[ALTURA_MUNDO - 1 - i][rect->x + rect->l - 1] = 'X'; // Lado direito do retângulo
        }
    }

    // Imprime o plano na consola
    for (int i = 0; i < ALTURA_MUNDO; i++) {
        for (int j = 0; j < LARGURA_MUNDO; j++) {
            printf("%c", plano[i][j]);
        }
        printf("\n");
    }
}