#include "plano.h"
#include <stdio.h>

// Função para inicializar o plano com espaços vazios
void startPlano(char plano[ALTURA_MUNDO][LARGURA_MUNDO]) {
    for (int i = 0; i < ALTURA_MUNDO; i++) {
        for (int j = 0; j < LARGURA_MUNDO; j++) {
            plano[i][j] = ' ';
        }
    }
}

// Função para imprimir o plano com os retângulos representados por 'X' e 'O'
void printPlano(Rectangle** retangulos, int numRetangulos, char plano[ALTURA_MUNDO][LARGURA_MUNDO]) {
    startPlano(plano);

    // Desenha os retângulos no plano
    for (int k = 0; k < numRetangulos; k++) {
        Rectangle* rect = retangulos[k];

        // Preencher as bordas
        for (int j = rect->x; j < rect->x + rect->l; j++) {
            plano[ALTURA_MUNDO - 1 - rect->y][j] = 'X';
            plano[ALTURA_MUNDO - 1 - (rect->y + rect->h - 1)][j] = 'X';
        }

        for (int i = rect->y; i < rect->y + rect->h; i++) {
            plano[ALTURA_MUNDO - 1 - i][rect->x] = 'X';
            plano[ALTURA_MUNDO - 1 - i][rect->x + rect->l - 1] = 'X';
        }

        // Preencher o interior
        for (int i = rect->y + 1; i < rect->y + rect->h - 1; i++) {
            for (int j = rect->x + 1; j < rect->x + rect->l - 1; j++) {
                plano[ALTURA_MUNDO - 1 - i][j] = 'O';
            }
        }
    }
    // Imprime o plano na consola
    for (int i = 0; i < ALTURA_MUNDO; i++) {
        for (int j = 0; j < LARGURA_MUNDO; j++) {
            printf("%c", plano[i][j]);
        }
        printf("\n");
    }
}